<%
' ExcelOLE 1.4.1
' Excel File access via OLE Automation
' Written by Hunter Beanland
' http://www.geocities.com/hbeanland/
' hbeanland@yahoo.com.au

Class ExcelOLE
	Public ErrorText
	Public VirtualFileName
	Public AbsoluteFileName
	Public Sheets()
	Public Columns()
	Public NumSheets
	Public NumColumns
	Public ExcelBook
	Public ExcelApp
	Private ActiveRow
	Private Row()
	
	Private Sub Class_Initialize
		ErrorText = ""
		ActiveRow = 1
	End Sub
	
	Public Property Get CurrentRow
		CurrentRow = ActiveRow
	End Property

	Public Property Let CurrentRow(ByVal NewRow)
		ActiveRow = NewRow
		if ActiveRow < 1 then ActiveRow = 1
		if ActiveRow > 65536 then ActiveRow = 65536
	End Property
		
	Private Function GetWorksheets
		'Cache worksheet names
		Dim WorkSheet
		NumSheets =0
		For each WorkSheet in ExcelBook.Worksheets
			redim preserve Sheets(NumSheets)
			Sheets(NumSheets) = WorkSheet.Name
			NumSheets = NumSheets+1
		Next
		if NumSheets =0 then
			ErrorText = "No named areas or worksheet tab names found"
			GetWorksheets = False
			exit function
		end if
		GetWorksheets = True
	End Function
	
	Private Sub GetColumns
		'Cache column names
		NumColumns =0
		while ExcelBook.ActiveSheet.Cells(1, NumColumns+1).Value <> ""
			Redim preserve Columns(NumColumns)
			Columns(NumColumns) = ExcelBook.ActiveSheet.Cells(1, NumColumns+1).Value
			NumColumns = NumColumns + 1
		wend
		if NumColumns =0 then
			ErrorText = "No column names found"
		end if
	End Sub

	Public Function OpenSpreadsheet(FileName)
		'Open existing spreadsheet
		'If Excel hangs on open: For multiple users, in your workbook select Tools, Share Workbook, check/tick: Allow changes by more than one user.
		Set ExcelApp = CreateObject("Excel.Application")
		ExcelApp.Application.Visible = False
		ExcelApp.Application.Interactive = False
		ExcelApp.Application.DisplayAlerts = False
		ExcelApp.Application.ScreenUpdating = False
		'Check and fix file name
		if instr(trim(FileName),":") = 2 then 
			AbsoluteFileName = trim(FileName)
		elseif instr(trim(FileName),".") = 1 then
			ErrorText = "Path must be full virtual or absolute (. and .. not allowed)"
			OpenSpreadsheet = False
			exit Function
		else
			VirtualFileName = trim(FileName)
			AbsoluteFileName = Server.MapPath(trim(FileName))
		end if
		On Error Resume Next
		Set ExcelBook = ExcelApp.Workbooks.Open(AbsoluteFileName)
		If not isobject(ExcelBook) then
			ErrorText = "Connection will not open - check file path, lock status and valid Excel file"
			OpenSpreadsheet = False
		Else
			GetWorksheets
			if GetWorksheets then
				OpenSpreadsheet = True
				ErrorText = ""
			else
				OpenSpreadsheet = False
			end if	
		End if
		On Error Goto 0
	End Function

	Public Function NewSpreadsheet(FileName)
		'Open (create) a new spreadsheet
		Set ExcelApp = CreateObject("Excel.Application")
		ExcelApp.Application.Visible = False
		ExcelApp.Application.Interactive = False
		ExcelApp.Application.DisplayAlerts = False
		ExcelApp.Application.ScreenUpdating = False
		'Check and fix file name
		if instr(trim(FileName),":") = 2 then 
			AbsoluteFileName = trim(FileName)
		elseif instr(trim(FileName),".") = 1 then
			ErrorText = "Path must be full virtual or absolute (. and .. not allowed)"
			NewSpreadsheet = False
			exit Function
		else
			VirtualFileName = trim(FileName)
			AbsoluteFileName = Server.MapPath(trim(FileName))
		end if
		On Error Resume Next
		Set ExcelBook = ExcelApp.Workbooks.Add
		ExcelBook.SaveAs(AbsoluteFileName)
		If not isobject(ExcelBook) then
			ErrorText = "Connection will not open - check file path, lock status and valid Excel file"
			NewSpreadsheet = False
		Else
			GetWorksheets
			if GetWorksheets then
				NewSpreadsheet = True
				ErrorText = ""
			else
				NewSpreadsheet = False
			end if	
		End if
		On Error Goto 0
	End Function
		
	Public Function OpenWorksheet(SheetName)
		'Open (make active) a worksheet
		if isarray(Sheets) then
			if instr(1,join(Sheets),SheetName) = 0 then
				ErrorText = "Not valid named area or worksheet tab name"
				OpenWorksheet = False
				exit Function
			end if
		end if
		ExcelBook.Worksheets(SheetName).Activate
		GetColumns
		ErrorText = ""
		OpenWorksheet = True
	End Function

	Public Function CopyWorksheet(SrcSheetName,DstSheetName)
		'Copy worksheet to new sheet
		Dim strNewSheet, WorkSheet
		if isarray(Sheets) then
			if instr(1,join(Sheets),SrcSheetName) = 0 then
				ErrorText = "Source worksheet doesn't exist"
				CopyWorksheet = False
				exit Function
			end if
			if instr(1,join(Sheets),DstSheetName) > 0 then
				ErrorText = "Destination worksheet already exists"
				CopyWorksheet = False
				exit Function
			end if
		end if
		with ExcelBook
			.Worksheets.add
			strNewSheet = "Sheet1"
			For each WorkSheet in ExcelBook.Worksheets
				if instr(1,WorkSheet.Name,"Sheet",1) = 1 then strNewSheet = WorkSheet.Name
			Next
			.Worksheets(strNewSheet).Name = DstSheetName
			.Worksheets(DstSheetName).Activate
			.Worksheets(DstSheetName).Select
			.Worksheets(SrcSheetName).Cells.Copy
        	.Worksheets(DstSheetName).Paste
		end with
		ErrorText = ""
		CopyWorksheet = True
	End Function
		
	Public Function ReadRow
		'Cache a row
		Dim ColumnsIndex
		ActiveRow = ActiveRow+1
		ReadRow = false
		if ActiveRow <= 65536 then
			for ColumnsIndex = 0 to NumColumns-1
				redim preserve Row(ColumnsIndex) 
				Row(ColumnsIndex) = ExcelBook.ActiveSheet.Cells(ActiveRow, ColumnsIndex+1).Value
				if Row(ColumnsIndex) <> "" then ReadRow = true
			next
		end if	
	End Function
	
	Public Sub CloseWorksheet
		'Not Required.
	End Sub
	
	Public Function ColumnData(ColNum)
		'Read column/cell from cached row
		if ColNum <= NumColumns-1 then
			ColumnData = Row(ColNum)
		else
			ColumnData = NULL
		end if	
	End Function
	
	Public Function CellRead(RowNum,ColNum)
		'Read from a cell
		if RowNum >0 and RowNum <65537 and ColNum >0 and ColNum <257 then
			CellRead = ExcelBook.ActiveSheet.Cells(RowNum, ColNum).Value
			ErrorText = ""
		else	
			ErrorText = "Row/Column out of bounds"
			CellRead = NULL
		end if	
	End Function
	
	Public Function CellWrite(RowNum,ColNum,CellValue)
		'Write to a cell
		if RowNum >0 and RowNum <65537 and ColNum >0 and ColNum <257 then
			ExcelBook.ActiveSheet.Cells(RowNum, ColNum).Value = CellValue
			CellWrite = True
			ErrorText = ""
		else
			CellWrite = False
			ErrorText = "Row/Column out of bounds"
		end if	
	End Function
	
	Public Function SaveSpreadsheet(NewFileName)
		'Save spreadheet or save as
		if NewFileName <> "" then
			'Save As (NewFileName)
			'Check and fix file name
			if instr(trim(NewFileName),":") = 2 then 
				AbsoluteFileName = trim(NewFileName)
			elseif instr(trim(NewFileName),".") = 1 then
				ErrorText = "Path must be full virtual or absolute (. and .. not allowed)"
				SaveSpreadsheetAs = False
				exit Function
			else
				VirtualFileName = trim(NewFileName)
				AbsoluteFileName = Server.MapPath(trim(NewFileName))
			end if
			On Error Resume Next
			ExcelBook.SaveAs AbsoluteFileName
		else
			'Save - may sometimes fail?? - Use Save As NewFileName
			On Error Resume Next
			ExcelBook.Save
		end if
		If ExcelBook.Saved then 
			ErrorText = ""
			SaveSpreadsheetAs = True
		else
			ErrorText = "Save Failed. Check write protection and file locks."
			SaveSpreadsheetAs = False
		end if	
		On Error Goto 0
	End Function
	
	Public Sub CloseSpreadsheet
		'Close and destroy
		On Error Resume Next
		If isobject(ExcelBook) then
			ExcelBook.Saved = True
			ExcelBook.Close
			Set ExcelBook = Nothing 
		end if	
		If isobject(ExcelApp) then
			ExcelApp.Application.Quit
			Set ExcelApp = Nothing
		end if	
		On Error Goto 0
	End Sub
	
	Private Sub Class_Terminate
		'Make sure it is closed (to release file locks and resources)
		CloseSpreadsheet
	End Sub
	
End Class	

%>